<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>Framework: framework::core::Thread Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_hds.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">Framework
   </div>
   <div id="projectbrief">Framework drone</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('classframework_1_1core_1_1_thread.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(9)"><span class="SelectionMark">&#160;</span>Properties</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classframework_1_1core_1_1_thread-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">framework::core::Thread Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p>Abstract class for a thread.  
 <a href="classframework_1_1core_1_1_thread.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_thread_8h_source.html">Thread.h</a>&gt;</code></p>
<div id="dynsection-0" onclick="return toggleVisibility(this)" class="dynheader closed" style="cursor:pointer;">
  <img id="dynsection-0-trigger" src="closed.png" alt="+"/> Inheritance diagram for framework::core::Thread:</div>
<div id="dynsection-0-summary" class="dynsummary" style="display:block;">
</div>
<div id="dynsection-0-content" class="dyncontent" style="display:none;">
 <div class="center">
  <img src="classframework_1_1core_1_1_thread.png" usemap="#framework::core::Thread_map" alt=""/>
  <map id="framework::core::Thread_map" name="framework::core::Thread_map">
<area href="classframework_1_1core_1_1_object.html" title="Base class for all Framework&#39;s classes. " alt="framework::core::Object" shape="rect" coords="0,0,239,24"/>
<area href="classframework_1_1actuator_1_1_bl_ctrl_v2__x4__speed.html" alt="framework::actuator::BlCtrlV2_x4_speed" shape="rect" coords="249,112,488,136"/>
<area href="classframework_1_1core_1_1_watchdog.html" title="Watchdog class. " alt="framework::core::Watchdog" shape="rect" coords="249,168,488,192"/>
<area href="classframework_1_1meta_1_1_uav_state_machine.html" title="State machine for UAV. " alt="framework::meta::UavStateMachine" shape="rect" coords="249,224,488,248"/>
<area href="classframework_1_1sensor_1_1_gx3__25__imu.html" title="Class for 3dmgx3-25 Imu. " alt="framework::sensor::Gx3_25_imu" shape="rect" coords="249,280,488,304"/>
<area href="classframework_1_1sensor_1_1_hokuyo_u_t_m30_lx.html" title="Classe intégrant le telemetre laser Hokuyo UTM 30lx. " alt="framework::sensor::HokuyoUTM30Lx" shape="rect" coords="249,336,488,360"/>
<area href="classframework_1_1sensor_1_1_host_eth_controller.html" title="Base Class for host side remote controls that talks to target side through ethernet connection..." alt="framework::sensor::HostEthController" shape="rect" coords="249,392,488,416"/>
<area href="classframework_1_1sensor_1_1_mb800.html" title="Class for mb800 gps receiver. " alt="framework::sensor::Mb800" shape="rect" coords="249,448,488,472"/>
<area href="classframework_1_1sensor_1_1_novatel.html" title="Class for Novatel gps receiver. " alt="framework::sensor::Novatel" shape="rect" coords="249,504,488,528"/>
<area href="classframework_1_1sensor_1_1_parrot_battery_monitor.html" title="Parrot battery monitor. " alt="framework::sensor::ParrotBatteryMonitor" shape="rect" coords="249,560,488,584"/>
<area href="classframework_1_1sensor_1_1_parrot_gps.html" title="Class for Ardrone 2 gps receiver. " alt="framework::sensor::ParrotGps" shape="rect" coords="249,616,488,640"/>
<area href="classframework_1_1sensor_1_1_parrot_nav_board.html" title="Class for ArDrone 2 sensors. " alt="framework::sensor::ParrotNavBoard" shape="rect" coords="249,672,488,696"/>
<area href="classframework_1_1sensor_1_1_simu_camera.html" title="Class for a simulation camera. " alt="framework::sensor::SimuCamera" shape="rect" coords="249,728,488,752"/>
<area href="classframework_1_1sensor_1_1_simu_gps.html" title="Class for a simulation GPS. " alt="framework::sensor::SimuGps" shape="rect" coords="249,784,488,808"/>
<area href="classframework_1_1sensor_1_1_simu_imu.html" title="Class for a simulation Imu. " alt="framework::sensor::SimuImu" shape="rect" coords="249,840,488,864"/>
<area href="classframework_1_1sensor_1_1_simu_laser.html" alt="framework::sensor::SimuLaser" shape="rect" coords="249,896,488,920"/>
<area href="classframework_1_1sensor_1_1_simu_us.html" title="Class for a simulation UsRangeFinder. " alt="framework::sensor::SimuUs" shape="rect" coords="249,952,488,976"/>
<area href="classframework_1_1sensor_1_1_srf08.html" title="Class for ultra sonic SRF08. " alt="framework::sensor::Srf08" shape="rect" coords="249,1008,488,1032"/>
<area href="classframework_1_1sensor_1_1_target_controller.html" title="Base Class for target side remote controls. " alt="framework::sensor::TargetController" shape="rect" coords="249,1064,488,1088"/>
<area href="classframework_1_1sensor_1_1_v4_l_camera.html" title="Base class for V4l camera. " alt="framework::sensor::V4LCamera" shape="rect" coords="249,1120,488,1144"/>
<area href="classframework_1_1sensor_1_1_vrpn_client.html" title="Class to connect to a Vrpn server. " alt="framework::sensor::VrpnClient" shape="rect" coords="249,1176,488,1200"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ade8360f01a17c3c59a8fcfa8a67af4e9"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_thread.html#ade8360f01a17c3c59a8fcfa8a67af4e9">Thread</a> (const <a class="el" href="classframework_1_1core_1_1_object.html">Object</a> *parent, std::string name, uint8_t priority)</td></tr>
<tr class="memdesc:ade8360f01a17c3c59a8fcfa8a67af4e9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#ade8360f01a17c3c59a8fcfa8a67af4e9">More...</a><br /></td></tr>
<tr class="separator:ade8360f01a17c3c59a8fcfa8a67af4e9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a27a72866b343b8734fd4427515d1e38f"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_thread.html#a27a72866b343b8734fd4427515d1e38f">~Thread</a> ()</td></tr>
<tr class="memdesc:a27a72866b343b8734fd4427515d1e38f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor.  <a href="#a27a72866b343b8734fd4427515d1e38f">More...</a><br /></td></tr>
<tr class="separator:a27a72866b343b8734fd4427515d1e38f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aeea6854b038e4cc558dfb8dbfc6f47fd"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_thread.html#aeea6854b038e4cc558dfb8dbfc6f47fd">Start</a> (void)</td></tr>
<tr class="memdesc:aeea6854b038e4cc558dfb8dbfc6f47fd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Start the thread.  <a href="#aeea6854b038e4cc558dfb8dbfc6f47fd">More...</a><br /></td></tr>
<tr class="separator:aeea6854b038e4cc558dfb8dbfc6f47fd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acd61dc2aef8db4619f5d65eb0aca3d40"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_thread.html#acd61dc2aef8db4619f5d65eb0aca3d40">SafeStop</a> (void)</td></tr>
<tr class="memdesc:acd61dc2aef8db4619f5d65eb0aca3d40"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set a stop flag.  <a href="#acd61dc2aef8db4619f5d65eb0aca3d40">More...</a><br /></td></tr>
<tr class="separator:acd61dc2aef8db4619f5d65eb0aca3d40"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a540728357836b08054eb1d2c659ce0e1"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_thread.html#a540728357836b08054eb1d2c659ce0e1">ToBeStopped</a> (void) const </td></tr>
<tr class="memdesc:a540728357836b08054eb1d2c659ce0e1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set a stop flag.  <a href="#a540728357836b08054eb1d2c659ce0e1">More...</a><br /></td></tr>
<tr class="separator:a540728357836b08054eb1d2c659ce0e1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a74b2dd5fda4079a47f67d89b832a02d1"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_thread.html#a74b2dd5fda4079a47f67d89b832a02d1">Join</a> (void)</td></tr>
<tr class="memdesc:a74b2dd5fda4079a47f67d89b832a02d1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Join the thread.  <a href="#a74b2dd5fda4079a47f67d89b832a02d1">More...</a><br /></td></tr>
<tr class="separator:a74b2dd5fda4079a47f67d89b832a02d1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7aefccd25fe4a0dd6fa76d03090b9bb2"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_thread.html#a7aefccd25fe4a0dd6fa76d03090b9bb2">SetPeriodUS</a> (uint32_t period_us)</td></tr>
<tr class="memdesc:a7aefccd25fe4a0dd6fa76d03090b9bb2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the period in micro second.  <a href="#a7aefccd25fe4a0dd6fa76d03090b9bb2">More...</a><br /></td></tr>
<tr class="separator:a7aefccd25fe4a0dd6fa76d03090b9bb2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a29632101695ddd794befd704c4cc1fd7"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a29632101695ddd794befd704c4cc1fd7"></a>
uint32_t&#160;</td><td class="memItemRight" valign="bottom"><b>GetPeriodUS</b> () const </td></tr>
<tr class="separator:a29632101695ddd794befd704c4cc1fd7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3d7e006f50eb03f350c251ad7b0a8924"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_thread.html#a3d7e006f50eb03f350c251ad7b0a8924">SetPeriodMS</a> (uint32_t period_ms)</td></tr>
<tr class="memdesc:a3d7e006f50eb03f350c251ad7b0a8924"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the period in milli second.  <a href="#a3d7e006f50eb03f350c251ad7b0a8924">More...</a><br /></td></tr>
<tr class="separator:a3d7e006f50eb03f350c251ad7b0a8924"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acea1b6d67d95524f1c248e8e00a1a4a7"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="acea1b6d67d95524f1c248e8e00a1a4a7"></a>
uint32_t&#160;</td><td class="memItemRight" valign="bottom"><b>GetPeriodMS</b> () const </td></tr>
<tr class="separator:acea1b6d67d95524f1c248e8e00a1a4a7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afb56b9c909587242815270979452f38e"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_thread.html#afb56b9c909587242815270979452f38e">IsPeriodSet</a> (void)</td></tr>
<tr class="memdesc:afb56b9c909587242815270979452f38e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns if period was set.  <a href="#afb56b9c909587242815270979452f38e">More...</a><br /></td></tr>
<tr class="separator:afb56b9c909587242815270979452f38e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3aa7c62bf562cb4211b79e1d25eaad8b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_thread.html#a3aa7c62bf562cb4211b79e1d25eaad8b">WaitPeriod</a> (void) const </td></tr>
<tr class="memdesc:a3aa7c62bf562cb4211b79e1d25eaad8b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Wait the period.  <a href="#a3aa7c62bf562cb4211b79e1d25eaad8b">More...</a><br /></td></tr>
<tr class="separator:a3aa7c62bf562cb4211b79e1d25eaad8b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a62d15f694800dc4ac777fbbb57890228"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_thread.html#a62d15f694800dc4ac777fbbb57890228">WaitUpdate</a> (const <a class="el" href="classframework_1_1core_1_1_i_o_device.html">IODevice</a> *device)</td></tr>
<tr class="memdesc:a62d15f694800dc4ac777fbbb57890228"><td class="mdescLeft">&#160;</td><td class="mdescRight">Wait update of an <a class="el" href="classframework_1_1core_1_1_i_o_device.html" title="Abstract class for input/ouput system. ">IODevice</a>.  <a href="#a62d15f694800dc4ac777fbbb57890228">More...</a><br /></td></tr>
<tr class="separator:a62d15f694800dc4ac777fbbb57890228"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af9c6b84365e82242f6066d15b783e59c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_thread.html#af9c6b84365e82242f6066d15b783e59c">Suspend</a> (void)</td></tr>
<tr class="memdesc:af9c6b84365e82242f6066d15b783e59c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Suspend the thread.  <a href="#af9c6b84365e82242f6066d15b783e59c">More...</a><br /></td></tr>
<tr class="separator:af9c6b84365e82242f6066d15b783e59c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aafb4dee5db8515e105717940c1e4850b"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_thread.html#aafb4dee5db8515e105717940c1e4850b">SuspendUntil</a> (<a class="el" href="namespaceframework_1_1core.html#a556a09521d9b94e1c9f0bfe6744d611d">Time</a> date)</td></tr>
<tr class="memdesc:aafb4dee5db8515e105717940c1e4850b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Suspend the thread with timeout.  <a href="#aafb4dee5db8515e105717940c1e4850b">More...</a><br /></td></tr>
<tr class="separator:aafb4dee5db8515e105717940c1e4850b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a998454819371b74a979ac4e5ba362c51"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_thread.html#a998454819371b74a979ac4e5ba362c51">Resume</a> (void)</td></tr>
<tr class="memdesc:a998454819371b74a979ac4e5ba362c51"><td class="mdescLeft">&#160;</td><td class="mdescRight">Resume the thread.  <a href="#a998454819371b74a979ac4e5ba362c51">More...</a><br /></td></tr>
<tr class="separator:a998454819371b74a979ac4e5ba362c51"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a02931f74dbd44574c48a48ef0101164b"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_thread.html#a02931f74dbd44574c48a48ef0101164b">IsSuspended</a> (void) const </td></tr>
<tr class="memdesc:a02931f74dbd44574c48a48ef0101164b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Is the thread suspended?  <a href="#a02931f74dbd44574c48a48ef0101164b">More...</a><br /></td></tr>
<tr class="separator:a02931f74dbd44574c48a48ef0101164b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a231938b0e81bd51f7e7e8f11b8bf45d6"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_thread.html#a231938b0e81bd51f7e7e8f11b8bf45d6">SleepUntil</a> (<a class="el" href="namespaceframework_1_1core.html#a556a09521d9b94e1c9f0bfe6744d611d">Time</a> time) const </td></tr>
<tr class="memdesc:a231938b0e81bd51f7e7e8f11b8bf45d6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sleep until absolute time.  <a href="#a231938b0e81bd51f7e7e8f11b8bf45d6">More...</a><br /></td></tr>
<tr class="separator:a231938b0e81bd51f7e7e8f11b8bf45d6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab40474f0d841d2854587bd44ec776171"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_thread.html#ab40474f0d841d2854587bd44ec776171">SleepUS</a> (uint32_t time_us) const </td></tr>
<tr class="memdesc:ab40474f0d841d2854587bd44ec776171"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sleep for a certain time in micro second.  <a href="#ab40474f0d841d2854587bd44ec776171">More...</a><br /></td></tr>
<tr class="separator:ab40474f0d841d2854587bd44ec776171"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5bdbf5a2c9d82a562436e9ae7e5ea4b1"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_thread.html#a5bdbf5a2c9d82a562436e9ae7e5ea4b1">SleepMS</a> (uint32_t time_ms) const </td></tr>
<tr class="memdesc:a5bdbf5a2c9d82a562436e9ae7e5ea4b1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sleep for a cartain time in milli second.  <a href="#a5bdbf5a2c9d82a562436e9ae7e5ea4b1">More...</a><br /></td></tr>
<tr class="separator:a5bdbf5a2c9d82a562436e9ae7e5ea4b1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classframework_1_1core_1_1_object"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classframework_1_1core_1_1_object')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classframework_1_1core_1_1_object.html">framework::core::Object</a></td></tr>
<tr class="memitem:a97617b01df8aedc07b2ba46ef4988994 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_object.html#a97617b01df8aedc07b2ba46ef4988994">Object</a> (const <a class="el" href="classframework_1_1core_1_1_object.html">Object</a> *parent=NULL, std::string name=&quot;&quot;, std::string type=&quot;&quot;)</td></tr>
<tr class="memdesc:a97617b01df8aedc07b2ba46ef4988994 inherit pub_methods_classframework_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#a97617b01df8aedc07b2ba46ef4988994">More...</a><br /></td></tr>
<tr class="separator:a97617b01df8aedc07b2ba46ef4988994 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac934815b59eb1cf1a47bdb114fa86da0 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_object.html#ac934815b59eb1cf1a47bdb114fa86da0">~Object</a> ()</td></tr>
<tr class="memdesc:ac934815b59eb1cf1a47bdb114fa86da0 inherit pub_methods_classframework_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor.  <a href="#ac934815b59eb1cf1a47bdb114fa86da0">More...</a><br /></td></tr>
<tr class="separator:ac934815b59eb1cf1a47bdb114fa86da0 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae19cf04d95b4cabb8c6064375b15337f inherit pub_methods_classframework_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_object.html#ae19cf04d95b4cabb8c6064375b15337f">ObjectName</a> (void) const </td></tr>
<tr class="memdesc:ae19cf04d95b4cabb8c6064375b15337f inherit pub_methods_classframework_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Name.  <a href="#ae19cf04d95b4cabb8c6064375b15337f">More...</a><br /></td></tr>
<tr class="separator:ae19cf04d95b4cabb8c6064375b15337f inherit pub_methods_classframework_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a49660b572cdbedc6a665d5d396ed00a1 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_object.html#a49660b572cdbedc6a665d5d396ed00a1">ObjectType</a> (void) const </td></tr>
<tr class="memdesc:a49660b572cdbedc6a665d5d396ed00a1 inherit pub_methods_classframework_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Type.  <a href="#a49660b572cdbedc6a665d5d396ed00a1">More...</a><br /></td></tr>
<tr class="separator:a49660b572cdbedc6a665d5d396ed00a1 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8dda2eca639eb56bb2c3f26de04f2678 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">const <a class="el" href="classframework_1_1core_1_1_object.html">Object</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_object.html#a8dda2eca639eb56bb2c3f26de04f2678">Parent</a> (void) const </td></tr>
<tr class="memdesc:a8dda2eca639eb56bb2c3f26de04f2678 inherit pub_methods_classframework_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Parent.  <a href="#a8dda2eca639eb56bb2c3f26de04f2678">More...</a><br /></td></tr>
<tr class="separator:a8dda2eca639eb56bb2c3f26de04f2678 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7fb6234586cd406b3bea93aadf01ba16 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">std::vector&lt; const <a class="el" href="classframework_1_1core_1_1_object.html">Object</a> * &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_object.html#a7fb6234586cd406b3bea93aadf01ba16">TypeChilds</a> (void) const </td></tr>
<tr class="memdesc:a7fb6234586cd406b3bea93aadf01ba16 inherit pub_methods_classframework_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Childs of the same type.  <a href="#a7fb6234586cd406b3bea93aadf01ba16">More...</a><br /></td></tr>
<tr class="separator:a7fb6234586cd406b3bea93aadf01ba16 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aee8de0c31d51e165fed466a4c8bcf6c4 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">std::vector&lt; const <a class="el" href="classframework_1_1core_1_1_object.html">Object</a> * &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_object.html#aee8de0c31d51e165fed466a4c8bcf6c4">Childs</a> (void) const </td></tr>
<tr class="memdesc:aee8de0c31d51e165fed466a4c8bcf6c4 inherit pub_methods_classframework_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Childs.  <a href="#aee8de0c31d51e165fed466a4c8bcf6c4">More...</a><br /></td></tr>
<tr class="separator:aee8de0c31d51e165fed466a4c8bcf6c4 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aec1974099e78e731ba9c3dd1ed05de94 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_object.html#aec1974099e78e731ba9c3dd1ed05de94">Information</a> (const char *function, int line, const char *format,...) const </td></tr>
<tr class="memdesc:aec1974099e78e731ba9c3dd1ed05de94 inherit pub_methods_classframework_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Formatted information.  <a href="#aec1974099e78e731ba9c3dd1ed05de94">More...</a><br /></td></tr>
<tr class="separator:aec1974099e78e731ba9c3dd1ed05de94 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abb73af04b52a2ba67a2d2ce1a74330a2 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_object.html#abb73af04b52a2ba67a2d2ce1a74330a2">Warning</a> (const char *function, const char *format,...) const </td></tr>
<tr class="memdesc:abb73af04b52a2ba67a2d2ce1a74330a2 inherit pub_methods_classframework_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Formatted warning.  <a href="#abb73af04b52a2ba67a2d2ce1a74330a2">More...</a><br /></td></tr>
<tr class="separator:abb73af04b52a2ba67a2d2ce1a74330a2 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6f48a765168b2fe4a629234e0b778559 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_object.html#a6f48a765168b2fe4a629234e0b778559">Error</a> (const char *function, const char *format,...) const </td></tr>
<tr class="memdesc:a6f48a765168b2fe4a629234e0b778559 inherit pub_methods_classframework_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Formatted error.  <a href="#a6f48a765168b2fe4a629234e0b778559">More...</a><br /></td></tr>
<tr class="separator:a6f48a765168b2fe4a629234e0b778559 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a56a6221f2ce124d7c53b15a423a47b08 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_object.html#a56a6221f2ce124d7c53b15a423a47b08">ErrorOccured</a> (bool recursive=true) const </td></tr>
<tr class="memdesc:a56a6221f2ce124d7c53b15a423a47b08 inherit pub_methods_classframework_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Has an errror occured?  <a href="#a56a6221f2ce124d7c53b15a423a47b08">More...</a><br /></td></tr>
<tr class="separator:a56a6221f2ce124d7c53b15a423a47b08 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:a6c6e2c6e3c7b8e5b9730a21eb175c193"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_thread.html#a6c6e2c6e3c7b8e5b9730a21eb175c193">WarnUponSwitches</a> (bool enable)</td></tr>
<tr class="memdesc:a6c6e2c6e3c7b8e5b9730a21eb175c193"><td class="mdescLeft">&#160;</td><td class="mdescRight">Warn if real time / non real time switches occur.  <a href="#a6c6e2c6e3c7b8e5b9730a21eb175c193">More...</a><br /></td></tr>
<tr class="separator:a6c6e2c6e3c7b8e5b9730a21eb175c193"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pub_types_classframework_1_1core_1_1_object"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classframework_1_1core_1_1_object')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classframework_1_1core_1_1_object.html">framework::core::Object</a></td></tr>
<tr class="memitem:a7201b52b50f64586d1ea82cc1f6a2e6f inherit pub_types_classframework_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a7201b52b50f64586d1ea82cc1f6a2e6f"></a>enum &#160;</td><td class="memItemRight" valign="bottom"><b>color_t</b> { <b>Auto</b> =0, 
<b>Red</b> =31, 
<b>Green</b> =32, 
<b>Orange</b> =33
 }</td></tr>
<tr class="separator:a7201b52b50f64586d1ea82cc1f6a2e6f inherit pub_types_classframework_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Abstract class for a thread. </p>
<p>To implement a thread, Run() method must be reimplemented. <br />
When <a class="el" href="classframework_1_1core_1_1_thread.html#aeea6854b038e4cc558dfb8dbfc6f47fd" title="Start the thread. ">Start()</a> is called, it will automatically call Run() reimplemented method. A thread can be periodic, in this case <a class="el" href="classframework_1_1core_1_1_thread.html#a3aa7c62bf562cb4211b79e1d25eaad8b" title="Wait the period. ">WaitPeriod()</a> will block untill period is met. <a class="el" href="classframework_1_1core_1_1_thread.html" title="Abstract class for a thread. ">Thread</a> can also e synnchronized with an <a class="el" href="classframework_1_1core_1_1_i_o_device.html" title="Abstract class for input/ouput system. ">IODevice</a>, using <a class="el" href="classframework_1_1core_1_1_thread.html#a62d15f694800dc4ac777fbbb57890228" title="Wait update of an IODevice. ">WaitUpdate()</a> method. <br />
<a class="el" href="classframework_1_1core_1_1_thread.html" title="Abstract class for a thread. ">Thread</a> period is by default 100ms. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="ade8360f01a17c3c59a8fcfa8a67af4e9"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">framework::core::Thread::Thread </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classframework_1_1core_1_1_object.html">Object</a> *&#160;</td>
          <td class="paramname"><em>parent</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>priority</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Constructor. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">parent</td><td>parent </td></tr>
    <tr><td class="paramname">name</td><td>name </td></tr>
    <tr><td class="paramname">priority</td><td>priority, should be &gt;20 (&lt;20 is reserved for internal use) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a27a72866b343b8734fd4427515d1e38f"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual framework::core::Thread::~Thread </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Destructor. </p>
<p>If thread is started, <a class="el" href="classframework_1_1core_1_1_thread.html#acd61dc2aef8db4619f5d65eb0aca3d40" title="Set a stop flag. ">SafeStop()</a> and <a class="el" href="classframework_1_1core_1_1_thread.html#a74b2dd5fda4079a47f67d89b832a02d1" title="Join the thread. ">Join()</a> will be automatically called. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="aeea6854b038e4cc558dfb8dbfc6f47fd"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void framework::core::Thread::Start </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Start the thread. </p>

</div>
</div>
<a class="anchor" id="acd61dc2aef8db4619f5d65eb0aca3d40"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void framework::core::Thread::SafeStop </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set a stop flag. </p>
<p><a class="el" href="classframework_1_1core_1_1_thread.html#a540728357836b08054eb1d2c659ce0e1" title="Set a stop flag. ">ToBeStopped()</a> will return true after calling this method. </p>

</div>
</div>
<a class="anchor" id="a540728357836b08054eb1d2c659ce0e1"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool framework::core::Thread::ToBeStopped </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set a stop flag. </p>
<p>Reimplemented Run() can poll this method to determine when to stop the thread.</p>
<dl class="section return"><dt>Returns</dt><dd>true if <a class="el" href="classframework_1_1core_1_1_thread.html#acd61dc2aef8db4619f5d65eb0aca3d40" title="Set a stop flag. ">SafeStop()</a> was called </dd></dl>

</div>
</div>
<a class="anchor" id="a74b2dd5fda4079a47f67d89b832a02d1"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void framework::core::Thread::Join </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Join the thread. </p>
<p>This method will block untill Run() returns. </p>

</div>
</div>
<a class="anchor" id="a7aefccd25fe4a0dd6fa76d03090b9bb2"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void framework::core::Thread::SetPeriodUS </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>period_us</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the period in micro second. </p>
<p>After calling this method, IsPeriodSet will return true.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">period_us</td><td>period in us </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a3d7e006f50eb03f350c251ad7b0a8924"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void framework::core::Thread::SetPeriodMS </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>period_ms</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the period in milli second. </p>
<p>After calling this method, IsPeriodSet will return true.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">period_ums</td><td>period in ms </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="afb56b9c909587242815270979452f38e"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool framework::core::Thread::IsPeriodSet </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns if period was set. </p>
<dl class="section return"><dt>Returns</dt><dd>true if a period was set using SetPeriodUS or SetPeriodMS false otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="a3aa7c62bf562cb4211b79e1d25eaad8b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void framework::core::Thread::WaitPeriod </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Wait the period. </p>
<p>This method will block untill period is met. <br />
If no period was set (see SetPeriodUS, SetPeriodMS and IsPeriodSet), this method returns immediately. </p>

</div>
</div>
<a class="anchor" id="a62d15f694800dc4ac777fbbb57890228"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int framework::core::Thread::WaitUpdate </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classframework_1_1core_1_1_i_o_device.html">IODevice</a> *&#160;</td>
          <td class="paramname"><em>device</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Wait update of an <a class="el" href="classframework_1_1core_1_1_i_o_device.html" title="Abstract class for input/ouput system. ">IODevice</a>. </p>
<p>This method will block untill <a class="el" href="classframework_1_1core_1_1_i_o_device.html#a50eb13bc82e98bc0e170d77bba026de4" title="Process the childs of type IODevice, and log if needed. ">IODevice::ProcessUpdate</a> is called. <br />
This method is usefull to synchronize a thread with an <a class="el" href="classframework_1_1core_1_1_i_o_device.html" title="Abstract class for input/ouput system. ">IODevice</a>.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">device</td><td><a class="el" href="classframework_1_1core_1_1_i_o_device.html" title="Abstract class for input/ouput system. ">IODevice</a> to wait update from </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="af9c6b84365e82242f6066d15b783e59c"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void framework::core::Thread::Suspend </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Suspend the thread. </p>
<p>This method will block untill <a class="el" href="classframework_1_1core_1_1_thread.html#a998454819371b74a979ac4e5ba362c51" title="Resume the thread. ">Resume()</a> is called. </p>

</div>
</div>
<a class="anchor" id="aafb4dee5db8515e105717940c1e4850b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool framework::core::Thread::SuspendUntil </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceframework_1_1core.html#a556a09521d9b94e1c9f0bfe6744d611d">Time</a>&#160;</td>
          <td class="paramname"><em>date</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Suspend the thread with timeout. </p>
<p>This method will block until <a class="el" href="classframework_1_1core_1_1_thread.html#a998454819371b74a979ac4e5ba362c51" title="Resume the thread. ">Resume()</a> is called or the absolute date specified occurs</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">date</td><td>absolute date in ns </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if thread is woken up by a call to Resume, false otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="a998454819371b74a979ac4e5ba362c51"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void framework::core::Thread::Resume </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Resume the thread. </p>
<p>This method will unblock the call to <a class="el" href="classframework_1_1core_1_1_thread.html#af9c6b84365e82242f6066d15b783e59c" title="Suspend the thread. ">Suspend()</a>. </p>

</div>
</div>
<a class="anchor" id="a02931f74dbd44574c48a48ef0101164b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool framework::core::Thread::IsSuspended </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Is the thread suspended? </p>
<dl class="section return"><dt>Returns</dt><dd>true if thread is suspended </dd></dl>

</div>
</div>
<a class="anchor" id="a231938b0e81bd51f7e7e8f11b8bf45d6"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void framework::core::Thread::SleepUntil </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceframework_1_1core.html#a556a09521d9b94e1c9f0bfe6744d611d">Time</a>&#160;</td>
          <td class="paramname"><em>time</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Sleep until absolute time. </p>
<p>This method will block untill time is reached.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">time</td><td>absolute time </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ab40474f0d841d2854587bd44ec776171"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void framework::core::Thread::SleepUS </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>time_us</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Sleep for a certain time in micro second. </p>
<p>This method will block untill time is elapsed.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">time_us</td><td>time to wait in micro second </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a5bdbf5a2c9d82a562436e9ae7e5ea4b1"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void framework::core::Thread::SleepMS </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>time_ms</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Sleep for a cartain time in milli second. </p>
<p>This method will block untill time is elapsed.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">time_ms</td><td>time to wait in milli second </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a6c6e2c6e3c7b8e5b9730a21eb175c193"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void framework::core::Thread::WarnUponSwitches </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>enable</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Warn if real time / non real time switches occur. </p>
<p>If enabled, a message with the call stack will be displayed in case of real time / non real time switches. <br />
This method can help to debug application and see if switches occur. <br />
Note that it as no effect if this method is called from the non real time Framework library.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">enable</td><td>enable or disable warns </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceframework.html">framework</a></li><li class="navelem"><a class="el" href="namespaceframework_1_1core.html">core</a></li><li class="navelem"><a class="el" href="classframework_1_1core_1_1_thread.html">Thread</a></li>
    <li class="footer">Generated on Tue Apr 12 2016 16:28:59 for Framework by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.7 </li>
  </ul>
</div>
</body>
</html>
